Home | History | Annotate | Line # | Download | only in contrib
dg-extract-results.sh revision 1.1.1.3
      1 #! /bin/sh
      2 
      3 # For a specified tool and optional list of test variants, extract
      4 # test results from one or more test summary (.sum) files and combine
      5 # the results into a new test summary file, sent to the standard output.
      6 # The resulting file can be used with test result comparison scripts for
      7 # results from tests that were run in parallel.  See usage() below.
      8 
      9 # Copyright (C) 2008, 2009, 2010, 2012 Free Software Foundation
     10 # Contributed by Janis Johnson <janis187 (at] us.ibm.com>
     11 #
     12 # This file is part of GCC.
     13 #
     14 # GCC is free software; you can redistribute it and/or modify
     15 # it under the terms of the GNU General Public License as published by
     16 # the Free Software Foundation; either version 3, or (at your option)
     17 # any later version.
     18 #
     19 # GCC is distributed in the hope that it will be useful,
     20 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     21 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     22 # GNU General Public License for more details.
     23 #
     24 # You should have received a copy of the GNU General Public License
     25 # along with GCC; see the file COPYING.  If not, write to
     26 # the Free Software Foundation, 51 Franklin Street, Fifth Floor,
     27 # Boston, MA 02110-1301, USA.
     28 
     29 PROGNAME=dg-extract-results.sh
     30 
     31 # Try to use the python version if possible, since it tends to be faster.
     32 PYTHON_VER=`echo "$0" | sed 's/sh$/py/'`
     33 if test "$PYTHON_VER" != "$0" &&
     34    test -f "$PYTHON_VER" &&
     35    python -c 'import sys, getopt, re, io, datetime, operator; sys.exit (0 if sys.version_info >= (2, 6) else 1)' \
     36      > /dev/null 2> /dev/null; then
     37   exec python $PYTHON_VER "$@"
     38 fi
     39 
     40 usage() {
     41   cat <<EOF >&2
     42 Usage: $PROGNAME [-t tool] [-l variant-list] [-L] sum-file ...
     43 
     44     tool           The tool (e.g. g++, libffi) for which to create a
     45                    new test summary file.  If not specified then all
     46                    specified sum files must be for the same tool.
     47     variant-list   One or more test variant names.  If the list is
     48                    not specified then one is constructed from all
     49                    variants in the files for <tool>.
     50     sum-file       A test summary file with the format of those
     51                    created by runtest from DejaGnu.
     52     If -L is used, merge *.log files instead of *.sum.  In this
     53     mode the exact order of lines may not be preserved, just different
     54     Running *.exp chunks should be in correct order.
     55 EOF
     56 }
     57 
     58 # Write a message to the standard error.
     59 
     60 msg() {
     61   echo "$@" >&2
     62 }
     63 
     64 # Parse the command-line options.
     65 
     66 VARIANTS=""
     67 TOOL=""
     68 MODE="sum"
     69 
     70 while getopts "l:t:L" ARG; do
     71   case $ARG in
     72   l)  VARIANTS="${VARIANTS} ${OPTARG}";;
     73   t)  test -z "$TOOL" || (msg "${PROGNAME}: only one tool can be specified"; exit 1);
     74       TOOL="${OPTARG}";;
     75   L)  MODE="log";;
     76   \?) usage; exit 0;;
     77   esac
     78 done
     79 shift `expr ${OPTIND} - 1`
     80 
     81 if test $# -lt 1 ; then
     82   usage
     83   exit 1
     84 fi
     85 
     86 TMPDIR=${TMPDIR-/tmp}
     87 SUM_FILES="$@"
     88 FIRST_SUM=$1
     89 TMP=
     90 trap 'EXIT_STATUS=$?; rm -rf $TMP && exit $EXIT_STATUS' 0
     91 # Create a (secure) tmp directory for tmp files.
     92 {
     93   TMP=`(umask 077 && mktemp -d -q "${TMPDIR}/dg-combine-results-$$-XXXXXX") 2>/dev/null` &&
     94   test -n "$TMP" && test -d "$TMP"
     95 } ||
     96 {
     97   TMP=${TMPDIR}/dg-combine-results-$$-$RANDOM
     98   (umask 077 && mkdir $TMP)
     99 } ||
    100 {
    101   msg "${PROGNAME}: cannot create a temporary directory"
    102   { (exit 1); exit 1; }
    103 }
    104 
    105 # Find a good awk.
    106 
    107 if test -z "$AWK" ; then
    108   for AWK in gawk nawk awk
    109   do
    110     if type $AWK 2>&1 | grep 'not found' > /dev/null 2>&1 ; then
    111       :
    112     else
    113       break
    114     fi
    115   done
    116 fi
    117 
    118 # Verify that the specified summary files exist.
    119 
    120 ERROR=0
    121 for FILE in $SUM_FILES
    122 do
    123   if ! test -f $FILE ; then
    124     msg "${PROGNAME}: file $FILE does not exist."
    125     ERROR=1
    126   fi
    127 done
    128 test $ERROR -eq 0 || exit 1
    129 
    130 # Test if grep supports the '--text' option
    131 
    132 GREP=grep
    133 
    134 if echo -e '\x00foo\x00' | $GREP --text foo > /dev/null 2>&1 ; then
    135   GREP="grep --text"
    136 else
    137   # Our grep does not recognize the '--text' option.  We have to
    138   # treat our files in order to remove any non-printable character.
    139   for file in $SUM_FILES ; do
    140     mv $file ${file}.orig
    141     cat -v ${file}.orig > $file
    142   done
    143 fi
    144 
    145 if [ -z "$TOOL" ]; then
    146   # If no tool was specified, all specified summary files must be for
    147   # the same tool.
    148 
    149   CNT=`$GREP '=== .* tests ===' $SUM_FILES | $AWK '{ print $3 }' | sort -u | wc -l`
    150   if [ $CNT -eq 1 ]; then
    151     TOOL=`$GREP '=== .* tests ===' $FIRST_SUM | $AWK '{ print $2 }'`
    152   else
    153     msg "${PROGNAME}: sum files are for multiple tools, specify a tool"
    154     msg ""
    155     usage
    156     exit 1
    157   fi
    158 else
    159   # Ignore the specified summary files that are not for this tool.  This
    160   # should keep the relevant files in the same order.
    161 
    162   SUM_FILES=`$GREP -l "=== $TOOL" $SUM_FILES`
    163   if test -z "$SUM_FILES" ; then
    164     msg "${PROGNAME}: none of the specified files are results for $TOOL"
    165     exit 1
    166   fi
    167 fi
    168 
    169 if [ "$TOOL" = acats ]; then
    170   # Acats *.sum or *.log files aren't dejagnu generated, and they have
    171   # somewhat different format.
    172   ACATS_AWK=${TMP}/acats.awk
    173   cat <<EOF > $ACATS_AWK
    174 BEGIN {
    175   print_prologue=1; curfile=""; insummary=0
    176   passcnt=0; failcnt=0; unsupcnt=0; failures=""
    177 }
    178 /^[ \t]*=== acats configuration ===/ {
    179   insummary=0
    180   if (print_prologue) print
    181   next
    182 }
    183 /^[ \t]*=== acats tests ===/ {
    184   if (print_prologue) print
    185   print_prologue=0
    186   next
    187 }
    188 /^Running chapter / {
    189   if (curfile) close (curfile)
    190   curfile="${TMP}/chapter-"\$3
    191   print >> curfile
    192   next
    193 }
    194 /^[ \t]*=== acats Summary ===/ {
    195   if (curfile) close (curfile)
    196   curfile=""
    197   insummary=1
    198   next
    199 }
    200 /^# of expected passes/		{ if (insummary == 1) passcnt += \$5; next; }
    201 /^# of unexpected failures/	{ if (insummary == 1) failcnt += \$5; next; }
    202 /^# of unsupported tests/	{ if (insummary == 1) unsupcnt += \$5; next; }
    203 /^\*\*\* FAILURES: / {
    204   if (insummary == 1) {
    205     if (failures) sub(/^\*\*\* FAILURES:/,"")
    206     failures=failures""\$0
    207   }
    208 }
    209 {
    210   if (print_prologue) { print; next }
    211   if (curfile) print >> curfile
    212 }
    213 END {
    214   system ("cat ${TMP}/chapter-*")
    215   print "		=== acats Summary ==="
    216   print "# of expected passes		" passcnt
    217   print "# of unexpected failures	" failcnt
    218   if (unsupcnt) print "# of unsupported tests		" unsupcnt
    219   if (failures) print failures
    220 }
    221 EOF
    222 
    223   rm -f ${TMP}/chapter-*
    224   $AWK -f $ACATS_AWK $SUM_FILES
    225   exit 0
    226 fi
    227 
    228 # If no variants were specified, find all variants in the remaining
    229 # summary files.  Otherwise, ignore specified variants that aren't in
    230 # any of those summary files.
    231 
    232 if test -z "$VARIANTS" ; then
    233   VAR_AWK=${TMP}/variants.awk
    234   cat <<EOF > $VAR_AWK
    235 /^Schedule of variations:/      { in_vars=1; next }
    236 /^$/                            { in_vars=0 }
    237 /^Running target/               { exit }
    238 { if (in_vars==1) print \$1; else next }
    239 EOF
    240 
    241   touch ${TMP}/varlist
    242   for FILE in $SUM_FILES; do
    243     $AWK -f $VAR_AWK $FILE >> ${TMP}/varlist
    244   done
    245   VARIANTS="`sort -u ${TMP}/varlist`"
    246 else
    247   VARS="$VARIANTS"
    248   VARIANTS=""
    249   for VAR in $VARS
    250   do
    251     $GREP "Running target $VAR" $SUM_FILES > /dev/null && VARIANTS="$VARIANTS $VAR"
    252   done
    253 fi
    254 
    255 # Find out if we have more than one variant, or any at all.
    256 
    257 VARIANT_COUNT=0
    258 for VAR in $VARIANTS
    259 do
    260   VARIANT_COUNT=`expr $VARIANT_COUNT + 1`
    261 done
    262 
    263 if test $VARIANT_COUNT -eq 0 ; then
    264   msg "${PROGNAME}: no file for $TOOL has results for the specified variants"
    265   exit 1
    266 fi
    267 
    268 cat $SUM_FILES \
    269   | $AWK '/^Running/ { if ($2 != "target" && $3 == "...") print "EXPFILE: "$2 } ' \
    270   | sort -u > ${TMP}/expfiles
    271 
    272 # Write the begining of the combined summary file.
    273 
    274 head -n 2 $FIRST_SUM
    275 echo
    276 echo "		=== $TOOL tests ==="
    277 echo
    278 echo "Schedule of variations:"
    279 for VAR in $VARIANTS
    280 do
    281   echo "    $VAR"
    282 done
    283 echo
    284 
    285 # For each test variant for the tool, copy test reports from each of the
    286 # summary files.  Set up two awk scripts from within the loop to
    287 # initialize VAR and TOOL with the script, rather than assuming that the
    288 # available version of awk can pass variables from the command line.
    289 
    290 for VAR in $VARIANTS
    291 do
    292   GUTS_AWK=${TMP}/guts.awk
    293   cat << EOF > $GUTS_AWK
    294 BEGIN {
    295   variant="$VAR"
    296   firstvar=1
    297   expfileno=1
    298   cnt=0
    299   print_using=0
    300   need_close=0
    301 }
    302 /^EXPFILE: / {
    303   expfiles[expfileno] = \$2
    304   expfilesr[\$2] = expfileno
    305   expfileno = expfileno + 1
    306 }
    307 /^Running target / {
    308   curvar = \$3
    309   if (variant == curvar && firstvar == 1) { print; print_using=1; firstvar = 0 }
    310   next
    311 }
    312 /^Using / {
    313   if (variant == curvar && print_using) { print; next }
    314 }
    315 /^Running .*\\.exp \\.\\.\\./ {
    316   print_using=0
    317   if (variant == curvar) {
    318     if (need_close) close(curfile)
    319     curfile="${TMP}/list"expfilesr[\$2]
    320     expfileseen[\$2]=expfileseen[\$2] + 1
    321     need_close=0
    322     testname="00"
    323     next
    324   }
    325 }
    326 /^\t\t=== .* ===$/ { curvar = ""; next }
    327 /^(PASS|XPASS|FAIL|XFAIL|UNRESOLVED|WARNING|ERROR|UNSUPPORTED|UNTESTED|KFAIL):/ {
    328   testname=\$2
    329   # Ugly hack for gfortran.dg/dg.exp
    330   if ("$TOOL" == "gfortran" && testname ~ /^gfortran.dg\/g77\//)
    331     testname="h"testname
    332 }
    333 /^$/ { if ("$MODE" == "sum") next }
    334 { if (variant == curvar && curfile) {
    335     if ("$MODE" == "sum") {
    336       printf "%s %08d|", testname, cnt >> curfile
    337       cnt = cnt + 1
    338     }
    339     filewritten[curfile]=1
    340     need_close=1
    341     print >> curfile
    342   } else
    343     next
    344 }
    345 END {
    346   n=1
    347   while (n < expfileno) {
    348     if (expfileseen[expfiles[n]]) {
    349       print "Running "expfiles[n]" ..."
    350       if (filewritten["${TMP}/list"n]) {
    351 	if (expfileseen[expfiles[n]] == 1)
    352 	  cmd="cat"
    353 	else
    354 	  cmd="LC_ALL=C sort"
    355 	if ("$MODE" == "sum")
    356 	  system (cmd" ${TMP}/list"n" | sed -n 's/^[^ ]* [^ |]*|//p'")
    357 	else
    358 	  system ("cat ${TMP}/list"n)
    359       }
    360     }
    361     n = n + 1
    362   }
    363 }
    364 EOF
    365 
    366   SUMS_AWK=${TMP}/sums.awk
    367   rm -f $SUMS_AWK
    368   cat << EOF > $SUMS_AWK
    369 BEGIN {
    370   variant="$VAR"
    371   tool="$TOOL"
    372   passcnt=0; failcnt=0; untstcnt=0; xpasscnt=0; xfailcnt=0; kpasscnt=0; kfailcnt=0; unsupcnt=0; unrescnt=0;
    373   curvar=""; insummary=0
    374 }
    375 /^Running target /		{ curvar = \$3; next }
    376 /^# of /			{ if (variant == curvar) insummary = 1 }
    377 /^# of expected passes/		{ if (insummary == 1) passcnt += \$5; next; }
    378 /^# of unexpected successes/	{ if (insummary == 1) xpasscnt += \$5; next; }
    379 /^# of unexpected failures/	{ if (insummary == 1) failcnt += \$5; next; }
    380 /^# of expected failures/	{ if (insummary == 1) xfailcnt += \$5; next; }
    381 /^# of unknown successes/	{ if (insummary == 1) kpasscnt += \$5; next; }
    382 /^# of known failures/		{ if (insummary == 1) kfailcnt += \$5; next; }
    383 /^# of untested testcases/	{ if (insummary == 1) untstcnt += \$5; next; }
    384 /^# of unresolved testcases/	{ if (insummary == 1) unrescnt += \$5; next; }
    385 /^# of unsupported tests/	{ if (insummary == 1) unsupcnt += \$5; next; }
    386 /^$/				{ if (insummary == 1)
    387 				    { insummary = 0; curvar = "" }
    388 				  next
    389 				}
    390 { next }
    391 END {
    392   printf ("\t\t=== %s Summary for %s ===\n\n", tool, variant)
    393   if (passcnt != 0) printf ("# of expected passes\t\t%d\n", passcnt)
    394   if (failcnt != 0) printf ("# of unexpected failures\t%d\n", failcnt)
    395   if (xpasscnt != 0) printf ("# of unexpected successes\t%d\n", xpasscnt)
    396   if (xfailcnt != 0) printf ("# of expected failures\t\t%d\n", xfailcnt)
    397   if (kpasscnt != 0) printf ("# of unknown successes\t\t%d\n", kpasscnt)
    398   if (kfailcnt != 0) printf ("# of known failures\t\t%d\n", kfailcnt)
    399   if (untstcnt != 0) printf ("# of untested testcases\t\t%d\n", untstcnt)
    400   if (unrescnt != 0) printf ("# of unresolved testcases\t%d\n", unrescnt)
    401   if (unsupcnt != 0) printf ("# of unsupported tests\t\t%d\n", unsupcnt)
    402 }
    403 EOF
    404 
    405   PVAR=`echo $VAR | sed 's,/,.,g'`
    406   TMPFILE=${TMP}/var-$PVAR
    407   rm -f $TMPFILE
    408   rm -f ${TMP}/list*
    409   cat ${TMP}/expfiles $SUM_FILES | $AWK -f $GUTS_AWK
    410   cat $SUM_FILES | $AWK -f $SUMS_AWK > $TMPFILE
    411   # If there are multiple variants, output the counts for this one;
    412   # otherwise there will just be the final counts at the end.
    413   test $VARIANT_COUNT -eq 1 || cat $TMPFILE
    414 done
    415 
    416 # Set up an awk script to get the combined summary counts for the tool.
    417 
    418 TOTAL_AWK=${TMP}/total.awk
    419 cat << EOF > $TOTAL_AWK
    420 BEGIN {
    421   tool="$TOOL"
    422   passcnt=0; failcnt=0; untstcnt=0; xpasscnt=0; xfailcnt=0; kfailcnt=0; unsupcnt=0; unrescnt=0
    423 }
    424 /^# of expected passes/		{ passcnt += \$5 }
    425 /^# of unexpected failures/	{ failcnt += \$5 }
    426 /^# of unexpected successes/	{ xpasscnt += \$5 }
    427 /^# of expected failures/	{ xfailcnt += \$5 }
    428 /^# of unknown successes/	{ kpasscnt += \$5 }
    429 /^# of known failures/		{ kfailcnt += \$5 }
    430 /^# of untested testcases/	{ untstcnt += \$5 }
    431 /^# of unresolved testcases/	{ unrescnt += \$5 }
    432 /^# of unsupported tests/	{ unsupcnt += \$5 }
    433 END {
    434   printf ("\n\t\t=== %s Summary ===\n\n", tool)
    435   if (passcnt != 0) printf ("# of expected passes\t\t%d\n", passcnt)
    436   if (failcnt != 0) printf ("# of unexpected failures\t%d\n", failcnt)
    437   if (xpasscnt != 0) printf ("# of unexpected successes\t%d\n", xpasscnt)
    438   if (xfailcnt != 0) printf ("# of expected failures\t\t%d\n", xfailcnt)
    439   if (kpasscnt != 0) printf ("# of unknown successes\t\t%d\n", kpasscnt)
    440   if (kfailcnt != 0) printf ("# of known failures\t\t%d\n", kfailcnt)
    441   if (untstcnt != 0) printf ("# of untested testcases\t\t%d\n", untstcnt)
    442   if (unrescnt != 0) printf ("# of unresolved testcases\t%d\n", unrescnt)
    443   if (unsupcnt != 0) printf ("# of unsupported tests\t\t%d\n", unsupcnt)
    444 }
    445 EOF
    446 
    447 # Find the total summaries for the tool and add to the end of the output.
    448 cat ${TMP}/var-* | $AWK -f $TOTAL_AWK
    449 
    450 # This is ugly, but if there's version output from the compiler under test
    451 # at the end of the file, we want it.  The other thing that might be there
    452 # is the final summary counts.
    453 tail -2 $FIRST_SUM | $GREP '^#' > /dev/null || tail -2 $FIRST_SUM
    454 
    455 exit 0
    456